/**

*/

class FibProblem implements Problem
{
   private int number;
   public long result;

   public FibProblem(int number)
   {
      this.number = number;
   }

   public int getSize()
   {
      return this.number;
   }

   public void solveSequentially()
   {
      result = seqFib(number);
   }

   private long seqFib(int n)
   {
      if (n <= 1)
         return n;
      else
         return seqFib(n-1) + seqFib(n-2);
   }

   public Problem leftSubproblem()
   {
      return new FibProblem(number - 1);
   }

   public Problem rightSubproblem()
   {
      return new FibProblem(number - 2);
   }
/*
   // It would be nice if this worked.
   public void combine(FibProblem left, FibProblem right)
   {
      this.result = left.result + right.result;
   }
*/
   public <T extends Problem> void combine(T left, T right)
   {
      long leftResult  = ((FibProblem)left).result;
      long rightResult = ((FibProblem)right).result;
      this.result = leftResult + rightResult;
   }
}