/**

*/

class FibProblem implements Problem<FibProblem>
{
   private int number;
   public long result;

   public FibProblem(int number)
   {
      this.number = number;
   }

   public int getSize()
   {
      return this.number;
   }

   public void solveSequentially()
   {
      result = seqFib(number);
   }

   private long seqFib(int n)
   {
      if (n <= 1)
         return n;
      else
         return seqFib(n-1) + seqFib(n-2);
   }

   public FibProblem leftSubproblem()
   {
      return new FibProblem(number - 1);
   }

   public FibProblem rightSubproblem()
   {
      return new FibProblem(number - 2);
   }

   public void combine(FibProblem left, FibProblem right)
   {
      this.result = left.result + right.result;
   }
}
