/**
http://homes.cs.washington.edu/~djg/teachingMaterials/spac/sophomoricParallelismAndConcurrency.pdf

*/

class SumThread extends java.lang.Thread
{
   int lo; // fields for communicating inputs
   int hi;
   int[] arr;
   int ans = 0; // for communicating result

   SumThread(int[] a, int l, int h)
   {
      lo=l; hi=h; arr=a;
   }

   public void run()  // overriding, must have this type
   {
      for(int i = lo; i < hi; i++)
      {
         ans += arr[i];
      }
   }
}


class C
{
   public static int numThreads;

   static int sum(int[] arr, int numThreads) throws java.lang.InterruptedException
   {
      int len = arr.length;
      int ans = 0;
      SumThread[] ts = new SumThread[numThreads];

      for(int i = 0; i < numThreads; i++)
      {
         ts[i] = new SumThread(arr,(i*len)/numThreads,((i+1)*len)/numThreads);
         ts[i].start();
      }

      for(int i = 0; i < numThreads; i++)
      {
         ts[i].join();
         ans += ts[i].ans;
      }
      return ans;
   }
}


public class Section_3_2
{
   public static void main(String[] args)
   {
   }
}