/**

*/

class FibProblem implements Problem<Long>
{
   private final int number;

   public FibProblem(int number)
   {
      this.number = number;
   }

   public int getSize()
   {
      return number;
   }

   public Long solveSequentially()
   {
      return seqFib(number);
   }

   private long seqFib(long n)
   {
      if (n <= 1)
         return n;
      else
         return seqFib(n-1) + seqFib(n-2);
   }

    public Problem<Long> leftSubproblem()
   {
      return new FibProblem(number - 1);
   }

   public Problem<Long> rightSubproblem()
   {
      return new FibProblem(number - 2);
   }

   public Long combine(Long left, Long right)
   {
      return left + right;
   }
}
